



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java正则表达式 非捕获组详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java正则表达式 非捕获组详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 22:52:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这几天看了下正则表达式，对非捕获组(non-capturing)进行下总结。<br />主要总结 1个 + 2组&nbsp; 一共5个。<br />(?:X) (?=X) (?&lt;=X) (?!X) (?&lt;!X)</p>
<p>一、先从(?:)非捕获组说起。<br />下面由一个例子引出非捕获组。</p>
<p>有两个金额：8899￥ 和 6688$ 。显然，前一个是8899元的人民币，后一个是6688元的美元。我现在需要一个正则，要求提炼出它们的货币金额和货币种类。正则可以这写：(<a href="//d/" rel="external nofollow noreferrer">\\d</a>)+([￥$])$&nbsp; (在java中测试，所以多了转义字符'\')<br />测试程序如下：</p>
<div>
<ol><li>Pattern&nbsp;p&nbsp;=&nbsp;Pattern.compile("(\\d+)([￥$])$");</li>
<li>String&nbsp;str&nbsp;=&nbsp;"8899￥";</li>
<li>Matcher&nbsp;m&nbsp;=&nbsp;p.matcher(str);</li>
<li>if(m.matches()){</li>
<li>System.out.println("货币金额:&nbsp;"&nbsp;+&nbsp;m.group(1));</li>
<li>System.out.println("货币种类:&nbsp;"&nbsp;+&nbsp;m.group(2));</li>
<li>}</li></ol>
</div>
<p>输出结果为：<br />货币金额: 8899<br />货币种类: ￥</p>
<p>OK,满足了要求。这里的正则分成了两个组，一个是(<a href="//d/" rel="external nofollow noreferrer">\\d</a>+)，一个是([￥$])，前一个组匹配货币金额，后一个组匹配货币种类。</p>
<p>现在，我需要这个正则可以匹配浮点数。如8899.56￥。我们都知道，现在少于一元钱基本上买不到东西了，所以我希望忽略小数部分，正则还是提炼出 8899 和 ￥。<br />那么正则如下：<br />[code="java"](<a href="//d+%29%28//?)(\\d" rel="external nofollow noreferrer">\\d+)(\\.?)(\\d</a>+)([￥$])$[/code]<br />这里用括号分了四组，所以要输出货币金额的整数部分和货币种类，要分别输了group(1),group(4)了。如果输出部分和正则是分开的，我希望只修改正则而不去修改输出部分的代码，也就是还是用group(1)，group(2)作为输出。由此可以引出非捕获组(?:)。<br />把前面的正则修改为：<br />[code="java"](<a href="//?)(?:\\d" rel="external nofollow noreferrer">\\d+)(?:\\.?)(?:\\d</a>+)([￥$])$[/code]<br />这样，还是用group(1),group(2)做为输出，同样输出了 8899 和 ￥<br />这个正则的中间两个组用到的就是非捕获组（?:），它可以理解为只分组而不捕获。</p>
<p>二、(?=)和(?&lt;=)<br />有的资料把它们叫做肯定式向前查找和肯定式向后查找；<br />有的资料也叫做肯定顺序环视和肯定逆序环视。</p>
<p>1、姑且不理它们的名称，看下面的例子：</p>
<div>
<ol><li>Pattern&nbsp;p&nbsp;=&nbsp;Pattern.compile("[0-9a-z]{2}(?=aa)");</li>
<li>String&nbsp;str&nbsp;=&nbsp;"12332aa438aaf";</li>
<li>Matcher&nbsp;m&nbsp;=&nbsp;p.matcher(str);</li>
<li>while(m.find()){</li>
<li>System.out.println(m.group());</li>
<li>}</li></ol>
</div>
<p>这段程序输出32 38<br />这个正则的意思是：匹配这么一个字符串，它要满足：是两位字符（数字，或字母），且[color=red]后面[/color]紧跟着两个a。<br />分析一下：<br />32aa&nbsp; 这个子串 满足这个条件，所以可以匹配到，又因为 (?=) 的部分是不捕获的，所以输出的只是 32，不包括aa。同理 38aa 也匹配这个正则，而输出仅是 38。</p>
<p>再深入看一下:<br />当str第一次匹配成功输出 32 后，程序要继续向后查找是否还有匹配的其它子串。那么这时应该从 32aa 的后一位开始向后查找，还是从 32 的后一位呢？也就是从索引 5 开始还是从 7 开始呢？有人可能想到是从 32aa 的下一位开始往后找，因为 32aa 匹配了正则，所以下一位当然是它的后面也就是从 4 开始。但实际上是从 32 的后一位也就是第一个 a 开始往后找。原因还是 (?=) 是非捕获的。<br />查阅API文档是这么注释的：</p>
<p>(?=X) X, via zero-width positive lookahead</p>
<p>可见zero-width（零宽度）说的就是这个意思。</p>
<p>现在，把字符串写的更有意思些：str = "aaaaaaaa";<br />看一下它的输出： aa aa aa<br />分析一下：<br />这个字符串一共有8个a。<br />第一次匹配比较容易找到，那就是前四个：aaaa ,当然第三和第四个 a 是不捕获的，所以输出是第一和第二个a；<br />接着继续查找，这时是从第三个a开始，三到六，这4个a区配到了，所以输出第三和第四个a；<br />接着继续查找，这时是从第五个a开始，五到八，这4个a区配到了，所以输出第五和第六个a；<br />接着往后查找，这时是从第七个a开始，显然，第七和第八个a,不满足正则的匹配条件，查找结束。<br />我们再延伸一下，刚说的情况的是(?=)放在捕获的字符串后面，它如果放在前面又是什么结果呢？<br />例子换成：</p>
<div>
<ol><li>Pattern&nbsp;p&nbsp;=&nbsp;Pattern.compile("(?=hopeful)hope");</li>
<li>String&nbsp;str&nbsp;=&nbsp;"hopeful";</li>
<li>Matcher&nbsp;m&nbsp;=&nbsp;p.matcher(str);</li>
<li>while(m.find()){</li>
<li>System.out.println(m.group());</li>
<li>}</li></ol>
</div>
<p>它的输出是hope。<br />正则的意思是：是否能匹配hopeful,如果能，则捕获hopeful中的hope。当然继续向后查找匹配的子串，是从f开始。<br />比较一下可以看出，(?=hopeful)hope 和 hope(?=ful),两个正则的效果其实是一样的。</p>
<p>2、下面说一下 (?&lt;=)<br />把正则改一下，<br />&nbsp;&nbsp;&nbsp; Pattern p = Pattern.compile("(?&lt;=aa)[0-9a-z]{2}");<br />字符串还是str = "12332aa438aaf";<br />它的输出：43。</p>
<p>这个正则的意思是：匹配这么一个字符串，它要满足：是两位字符（数字或字母），且[color=red]前面[/color]紧跟的是两个字母 a 。</p>
<p>同样，深入一下，把str换成str = "aaaaaaaa";看一下输出是什么，同样也是：aa aa aa<br />分析一下：<br />第一次匹配不用说，是前四个a，输出的是第三和第四个a;<br />继续向后查找，从第五个a开始，程序发现，第五个和第六个a满足，因为是两位字符，且满足前面紧跟着两个a(第三和第四个a)。所以匹配成功，输出第五个和第六个a;<br />继续向后查找，从第七个a开始，程序发现，第七个和第八个a满足，因为是两位字符，且满足前面紧跟着两个a(第五和第六个a)。所以匹配成功，输出第七和第八个a。查找结束。</p>
<p>三、(?!)和(?&lt;!)<br />从外观上看，和前面一组很相似，区别就是把 &lsquo;=&rsquo; 换成了 &lsquo;!&rsquo;<br />那么意义刚好也是相反的。<br />[0-9a-z]{2}(?!aa)&nbsp;&nbsp;&nbsp; 意思是：匹配两个字符，且后面紧跟着的不是aa<br />(?&lt;=aa)[0-9a-z]{2}&nbsp; 意思是：匹配两个字符，且前面紧跟着的不是aa<br />用法和前面讲的差不多，这里不再详述。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1p7gzq.html">调试必备---console</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvy06zq.html">AX2009按照批次生产日期预留</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rvdle8.html">【推荐】iOS带有加载网络图片进度的UIImageView</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1mwn69.html">tarjan总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/96onxlv9.html">SHELL脚本自动备份Linux系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1g4nr9.html">打造支持apk下载和html5缓存的 IIS（配合一个超简单的android APP使用）具体解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z6nyz9.html">js中return false，return，return true的使用方法及区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1oknj8.html">ORA-00911&colon; invalid character</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmwn609.html">linux下 tags相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zd1jg9.html">python实战第一天-socket模块练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzv3708.html">【Linux笔记&lpar;001&rpar; 】-- centos7 系统目录结构与文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kxdg69.html">Swift中的&amp;quot&semi;可溢出&amp;quot&semi;算术运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgrpgm8.html">晒stlink以及stm8&OpenCurlyDoubleQuote;开发板&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17o4xq.html">基于flexbox纯css框架的解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllllz0q.html">POJ - 3278   Catch That Cow    bfs    线性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdd00j9.html">C&num;设计模式之五原型模式（Prototype Pattern）【创建型】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ry5z68.html">Python查看与安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e42d0m9.html">HTML for android  移动小球</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5x1vmq.html">JAVA 线程Join</a>
		</li>
						<li><a href="https://www.batexi.com/a/953nxym8.html">linux系统日志&lowbar;&lowbar;ratelimit&colon; N callbacks suppressed</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8okjn3e9.html">struts2 通用标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gme1k79.html">C&plus;&plus;-dynamic&lowbar;cast的用处</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdjjor8.html">php变量的判空和类型判断</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wjjroq.html">RAD&comma;V模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1y4ge9.html">Oracle GoldenGate 12c 新特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdj5jk8.html">C&plus;&plus;数据结构之Linked Stack&lpar;链式栈&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmjnp19.html">weblogic服务器的简单使用（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnkene8.html">IOS上传图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjdx349.html">Emacs常用命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjdgpy9.html">定时同步时间与crontab</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
